
//GPIO궨
#define	DATA_GPIO        IOID_26
#define CLK_GPIO         IOID_27

//GPIOù
PIN_Config GPIOConfig[] = {
    DATA_GPIO | PIN_GPIO_OUTPUT_DIS | PIN_INPUT_EN | PIN_PULLDOWN,
    CLK_GPIO | PIN_GPIO_OUTPUT_DIS| PIN_INPUT_EN | PIN_PULLUP, 
    PIN_TERMINATE
};

//
static PIN_State    GPIOPinState;
static PIN_Handle   hGPIOPinsHandle;

static u8 ClkNum = 0;       //CLKжϼ

//ڲú
static void CLK_GPIOIsrCallback(PIN_Handle handle, PIN_Id pinId);

//------------------------------------------------------------------------------
//    	void GPIO_Init(void)
//    	λƼGPIORTCʱӳʼ
//ڲ	
//ز	
//˵    	
//------------------------------------------------------------------------------
void GPIO_Init(void)
{
    BleSDKManagerInfo_t err;               // ״̬      
    err = DriverIOOpen(&hGPIOPinsHandle,&GPIOPinState,(const PIN_Config *)GPIOConfig);  //IO
    
    if(err != MANAGER_INFO_REQUEST_IO_SUCCESS){                                //һIO򿪳ɹ ûIO  
        return;
    }  
  
    err = DriverIORegisterIntCallBack(&hGPIOPinsHandle,CLK_GPIOIsrCallback);      //עһioжϻص    
    if(err != MANAGER_INFO_CONTROL_IO_SUCCESS){       
        return;
    }
    
    err = DriverIOSetConfig(&hGPIOPinsHandle,PIN_BM_IRQ,CLK_GPIO | PIN_IRQ_NEGEDGE);//CLK_GPIOжϹ    
    if(err != MANAGER_INFO_CONTROL_IO_SUCCESS){
        return;
    }
    
#ifdef POWER_SAVING                                                         //ϵͳʡ繦 ҪΪioûѹ(ʹ߱˯״̬ͨжϻmcuĹ)
    err = DriverIOSetConfig(&hGPIOPinsHandle,PINCC26XX_BM_WAKEUP,CLK_GPIO | PINCC26XX_WAKEUP_NEGEDGE);//CLK_GPIOжϻѹ
    
    if(err != MANAGER_INFO_CONTROL_IO_SUCCESS){    
        return;
    }
#endif
    
    AONRTCChannelDisable(AON_RTC_CH1);
    AONRTCModeCh1Set(AON_RTC_MODE_CH1_CAPTURE);
    AONEventRtcSet(AON_EVENT_IO);
    AONRTCChannelEnable(AON_RTC_CH1);
}


//------------------------------------------------------------------------------
//      CLK_GPIOIsrCallback(PIN_Handle handle, PIN_Id pinId)
//      ioжϻص
//ڲ  
//ز  
//˵      
//------------------------------------------------------------------------------
static void CLK_GPIOIsrCallback(PIN_Handle handle, PIN_Id pinId)
{
    static u32 uiDataTemp = 0;    
    static u32 CLKedgeTimingCurrectValue[2] = {0};  
    u32 edgeTimingCurrectValue = 0;
    
    g_uiShutDownClk = 0;    //shutdownģʽʱ
      
    if(ClkNum == 0){
//        CLKedgeTimingCurrectValue[0] = AONRTCCurrentCompareValueGet();
        CLKedgeTimingCurrectValue[0] = AONRTCCaptureValueCh1Get();
        AONRTCEventClear(AON_RTC_CH1);
    }
    else{
//        CLKedgeTimingCurrectValue[1] = AONRTCCurrentCompareValueGet();
        CLKedgeTimingCurrectValue[1] = AONRTCCaptureValueCh1Get();
        AONRTCEventClear(AON_RTC_CH1);
        if(CLKedgeTimingCurrectValue[1] >= CLKedgeTimingCurrectValue[0])
            edgeTimingCurrectValue = CLKedgeTimingCurrectValue[1] - CLKedgeTimingCurrectValue[0];
        else
            edgeTimingCurrectValue = CLKedgeTimingCurrectValue[1] + (0xFFFFFFFF - CLKedgeTimingCurrectValue[0]);
        CLKedgeTimingCurrectValue[0] = CLKedgeTimingCurrectValue[1];
        if(edgeTimingCurrectValue > 328){ //5ms5ms *(1000 / 65535)
            ClkNum = 0;
            uiDataTemp = 0;
        }
    }
    if(1 == DriverIOGetInputValue(DATA_GPIO))   //ȡIOƽ
        uiDataTemp = uiDataTemp + (1 << ClkNum);
        
    ClkNum += 1;
    if(ClkNum >= 28){	//ݶȡ
        ClkNum = 0;
        g_uiData = uiDataTemp;
        g_cDataFinsh = 1;
    }
}
